openapi: 3.0.1
info:
  title: CustomerCRM
  version: v1.0
  description: Api para registrar clientes
  termsOfService: 'http://terms-of-service.com'
  contact:
    email: contacto@ceiba.com.co
  license:
    name: GNU GPL
    url: 'https://license.com'
servers:
  - url: https://localhost:8082/crm
tags:
  - name: CustomerCRM
    description: CRUD para un cliente del banco
paths:
  /register:
    post:
      summary: Registra un cliente
      description: Registra un cliente en la base de datos
      requestBody:
        description: "Información del cliente"
        required: true
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/CustomerInfo"
      operationId: registerClient
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CRMRegisterResponse'
              example:
                data:
                  id: 123
      tags:
        - CustomerCRM
  /all:
    get:
      summary: Devuelve todos los clientes
      description: Devuelve todos los clientes registrados por el servicio
      operationId: getAllClients
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CRMConsultResponse'
      tags:
        - CustomerCRM
  /remove/{id}:
    delete:
      summary: Eliminar un cliente
      description: Elimina un cliente que fue registrado por el servicio
      parameters:
        - in: path
          name: id
          schema:
            type: integer
            format: int64
          required: true
          description: ID del cliente a eliminar
      operationId: removeClient
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CRMDeleteResponse'
      tags:
        - CustomerCRM
components:
  schemas:
    CustomerInfo:
      type: object
      properties:
        documentType:
          type: string
        document:
          type: string
        name:
          type: string
        lastName:
          type: string
        documentIssueDate:
          type: string
          format: date
        birthDate:
          type: string
          format: date
        email:
          type: string
          format: email
        cellphone:
          type: string
    CRMRegisterResponse:
      type: object
      properties:
        data:
          type: object
          properties:
            id:
              type: integer
              format: int64
              minimum: 1
        errores:
          type: array
          items:
            $ref: '#/components/schemas/Error'
    CRMConsultResponse:
      type: object
      properties:
        data:
          type: array
          items:
            type: object
        errores:
          type: array
          items:
            $ref: '#/components/schemas/Error'
    CRMDeleteResponse:
      type: object
      properties:
        data:
          type: object
          properties:
            removed:
              type: boolean
        errores:
          type: array
          items:
            $ref: '#/components/schemas/Error'
    Error:
      type: object
      properties:
        codigo:
          type: string
        valor:
          type: string